//=============================================================================
// DX CugptCgV~[^̃Tv
//-----------------------------------------------------------------------------
//=============================================================================

#include <DxLib.h>
#include <LuminoMathDxLib.h>
#include "../Common.h"
using namespace Lumino;

int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	ChangeWindowMode(TRUE);

	if (DxLib_Init() == -1)
		return -1;

	int playerModel = MV1LoadModel(LOCAL_RESOURCE("Plane1.x"));
	int skyModel = MV1LoadModel(LOCAL_RESOURCE("BG_Sky1.x"));
	int groundModel = MV1LoadModel(LOCAL_RESOURCE("Ground1.x"));

	SetCameraNearFar(1.0f, 10000.0f);
	SetupCamera_Perspective(Math::PI / 2);

	Quaternion playerRot;			// @̉]
	Vector3 playerPos;				// @̈ʒu
	float velocity = 5.0f;			// @̑x
	float rotVelocity = 0.02f;		// @̉]x

	// C[v
	while (ProcessMessage() == 0 && CheckHitKey(KEY_INPUT_ESCAPE) == 0)
	{
		//-----------------------------------------------------
		// @̎pXV

		//  L[
		if (CheckHitKey(KEY_INPUT_DOWN) == 1)
		{
			// sb`͎@_ɂƂƁAXA܂EƂ]ƍl邱ƂłB
			// X \xNg (1, 0, 0) ŁAVector3::UnitX 萔\B
			// ̃xNg@݂̌̉]p (playerRot) ōWϊƁA
			// ݂̎p猩E킩B axis ƂB
			Vector3 axis = Vector3::Transform(Vector3::UnitX, playerRot);

			// ꂽEƂāA-rotVelocity (WAP) A
			// ݂̉]pɉ]B
			playerRot.RotateAxis(axis, -rotVelocity);
		}
		//  L[
		if (CheckHitKey(KEY_INPUT_UP) == 1)
		{
			Vector3 axis = Vector3::Transform(Vector3::UnitX, playerRot);
			playerRot.RotateAxis(axis, rotVelocity);
		}
		//  L[
		if (CheckHitKey(KEY_INPUT_LEFT) == 1)
		{
			// [͎@_ɂƂƁAZ̉]ƂȂB
			// Z\xNg (0, 0, 1) ŁAVector3::UnitZ 萔\B
			// ̓sb`̎ƓB
			Vector3 axis = Vector3::Transform(Vector3::UnitZ, playerRot);
			playerRot.RotateAxis(axis, rotVelocity);
		}
		//  L[
		if (CheckHitKey(KEY_INPUT_RIGHT) == 1)
		{
			Vector3 axis = Vector3::Transform(Vector3::UnitZ, playerRot);
			playerRot.RotateAxis(axis, -rotVelocity);
		}

		// @OiB
		// ܂[Ɠ@Őʕ߂B
		// ͒PʃxNgŁAx|邱ƂŎ@̈ʒuǂꂾi߂΂悢킩B
		Vector3 front = Vector3::Transform(Vector3::UnitZ, playerRot);
		playerPos += front * velocity;


		//-----------------------------------------------------
		// J̎pXV
		
		// J̈ʒu͎@ 5.0 ɗꂽƂɂB
		// @̃[Ɠ@ŁAw -5.0 ̈ʒu߂ĂB
		Vector3 back = Vector3::Transform(Vector3(0, 0, -5.0f), playerRot);
		Vector3 cameraPos = playerPos + back;

		// ܂łƓWϊŋ߂B
		// ̕ (0, 1, 0) ŁAVector3::UnitY 萔\B
		Vector3 cameraUp = Vector3::Transform(Vector3::UnitY, playerRot);

		// Kvȏ񂪑BJ̎pݒ肷
		SetCameraPositionAndTargetAndUpVec(cameraPos, playerPos, cameraUp);
		

		//-----------------------------------------------------
		// `揈

		ClearDrawScreen();

		// wíAn`߂荞ŌȂ悤 ZWrite 𖳌ɂĕ`悷
		MV1SetPosition(skyModel, playerPos);
		MV1SetWriteZBuffer(skyModel, FALSE);
		MV1DrawModel(skyModel);

		// nʂ̕` ()
		MV1SetWireFrameDrawFlag(groundModel, FALSE);
		MV1SetOpacityRate(groundModel, 0.2f);
		MV1DrawModel(groundModel);

		// nʂ̕` (C[t[)
		MV1SetWireFrameDrawFlag(groundModel, TRUE);
		MV1SetOpacityRate(groundModel, 1.0f);
		MV1DrawModel(groundModel);

		// NH[^jIƈʒuxNg烏[hWϊs߁A@̎pƂĐݒ肷
		Matrix mat = Matrix::AffineTransformation(
			Vector3::One,	// g嗦 (1, 1, 1)
			Vector3::Zero,	// ]̌_̓f̌_
			playerRot,		// ]
			playerPos);		// ʒu
		MV1SetMatrix(playerModel, mat);
		MV1DrawModel(playerModel);

		// [܂] ̕Ƃɉʂ̋PxグB
		// ̌Ǝ@̌œςƁA݂ɊSɌƂ -1.0 Ał 0.0 ԂB
		// ł -0.5 ` -1.0 ̊ԂŏXɖ邭ĂB
		Vector3 ligntDir(1, -1, -1);
		ligntDir.Normalize();
		float dot = Vector3::Dot(ligntDir, mat.GetFront());
		if (dot < -0.5f)
		{
			SetDrawBlendMode(DX_BLENDMODE_ALPHA, (int)(255 * (-(dot + 0.5f))));
			DrawBox(0, 0, 640, 480, GetColor(255, 255, 255), TRUE);
		}

		// info
		SetDrawBlendMode(DX_BLENDMODE_ALPHA, 255);
		DrawString(0, 0, "  L[Ń[", GetColor(100, 100, 100));
		DrawString(0, 16, "  L[Ńsb`", GetColor(100, 100, 100));

		ScreenFlip();
	}

	DxLib_End();
	return 0;
}